;============================================
; Strings -- a string finder
;
; To do:
;  o Fix flaky listbox behavior (or use other control)
;  o Add write strings to file function
;  o Add menu item or control to allow/disallow spaces
;  o Add control to set minimum/maximum string length
;============================================


	include \masm32\include\masm32rt.inc


;============================================
; Defines, macros, prototypes, etc.
;============================================

WinMain			PROTO :DWORD
;StringsWinProc		PROTO hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
OpenFileDlg		PROTO hWin:HWND, fileOpenNamePtr:DWORD

$mainWindowWidth	EQU 500
$mainWindowHeight	EQU 800

;===== Window styles: =====
$mainWinAttrs		EQU WS_OVERLAPPEDWINDOW OR WS_CLIPCHILDREN OR WS_VISIBLE
$stringsWinAttrs	EQU WS_CHILD OR WS_VISIBLE OR LBS_HASSTRINGS OR LBS_SORT \
				OR WS_VSCROLL OR LBS_NOSEL OR LBS_DISABLENOSCROLL

;===== Menu items: =====
$menuOpenFile		EQU 1101
$menuWriteStrings	EQU 1102
$menuExit		EQU 1103

;===== String stuff: =====
$minStringLen		EQU 5
$maxStringLen		EQU 40
$ASCIImin		EQU ' '
$ASCIImax		EQU '}'			;Right curly brace

$fileOpenStrLen		EQU 260

;===== Window background colors: =====
$bkRED			EQU 254
$bkGRN			EQU 243
$bkBLUE			EQU 199

$BkColor		EQU $bkRED OR ($bkGRN SHL 8) OR ($bkBLUE SHL 16)

$stringsFontSize	EQU 16

;============================================
; HERE BE DATA
;============================================
.data

InstanceHandle		HWND ?
MainWinHandle		HWND ?
StringsWinHandle	HWND ?

ReadFileHandle		HANDLE ?
ReadFileSize		DD ?

StringsFileHandle	HANDLE ?

StringsFontHandle	HFONT ?

HeapHandle		HANDLE ?
HeapPtr			DD ?

OldListboxProcPtr	DD ?

AllowSpaces		DW FALSE

MainClassName		DB "StringFinder", 0
StringsClassName	DB "listbox", 0

MainTitleText		DB "StringFinder", 0

FontName		DB "Courier New", 0

FileOpenDlgTitle	DB "Pick file to find strings in:", 0
FileStartPathStr	DB ".\*.*", 0

FileOpenErrMsg		DB "Couldn't open file, sorry.", 0
Readfailmsg		DB "Couldn't read file!", 0
Memfailmsg		DB "Couldn't allocate memory!", 0
ErrorCaption		DB "Error!", 0

;============================================
; CODE LIVES HERE
;============================================
.code


start:
	INVOKE	GetModuleHandle, NULL
	MOV	InstanceHandle, EAX

	INVOKE	WinMain, EAX
	INVOKE	ExitProcess, EAX


;====================================================================
; Mainline proc
;====================================================================

WinMain	PROC hInst:DWORD
	LOCAL	wc:WNDCLASSEX, msg:MSG, brush:HBRUSH, wX:DWORD, wY:DWORD, hMenu:HMENU


; Get handle to heap memory to allocate later:
	INVOKE	GetProcessHeap
	MOV	HeapHandle, EAX

; Create  brush to set background color:
	INVOKE	CreateSolidBrush, $BkColor
	MOV	brush, EAX

; Load menu from resource in .exe:
	INVOKE	LoadMenu, hInst, 600		;menu ID
	MOV	hMenu, eax

; Register class for parent window:
	MOV	wc.cbSize, SIZEOF WNDCLASSEX
	MOV	wc.style,  CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
	MOV	wc.lpfnWndProc, OFFSET MainWindowProc
	MOV	wc.cbClsExtra, NULL
	MOV	wc.cbWndExtra, NULL
	MOV	EAX, hInst
	MOV	wc.hInstance, EAX
	MOV	EAX, brush
	MOV	wc.hbrBackground, EAX
	MOV	wc.lpszMenuName,  NULL
	MOV	wc.lpszClassName, OFFSET MainClassName
;	INVOKE	LoadIcon, hInst, 500    ; icon ID
;	MOV	wc.hIcon, EAX
	MOV	wc.hIcon, NULL
	INVOKE	LoadCursor, NULL, IDC_ARROW
	MOV	wc.hCursor, EAX
	MOV	wc.hIconSm, 0
	INVOKE	RegisterClassEx, ADDR wc

	INVOKE	GetSystemMetrics, SM_CXSCREEN
	MOV	EDX, $mainWindowWidth
	CALL	CenterDim
	MOV	wX, EAX
	INVOKE	GetSystemMetrics, SM_CYSCREEN
	MOV	EDX, $mainWindowHeight
	CALL	CenterDim
	MOV	wY, EAX

; Create our main window:
	INVOKE	CreateWindowEx, WS_EX_OVERLAPPEDWINDOW, ADDR MainClassName, ADDR MainTitleText,
		$mainWinAttrs, wX, wY, $mainWindowWidth, $mainWindowHeight,
		NULL, hMenu, hInst, NULL
	MOV	MainWinHandle, EAX


;============= Message loop ===================
msgloop:
	INVOKE	GetMessage, ADDR msg, NULL, 0, 0
	OR	EAX, EAX				;EAX = 0 = exit
	JZ	exit99
	INVOKE	TranslateMessage, ADDR msg
	INVOKE	DispatchMessage, ADDR msg
	JMP	msgloop

exit99:	INVOKE	DeleteObject, StringsFontHandle
	MOV	EAX, msg.wParam
	RET

WinMain		ENDP


;====================================================================
; Main Window Proc
;====================================================================

MainWindowProc	PROC hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
		LOCAL gpRect:RECT
		LOCAL fileOpenName[260]:BYTE, scrollInfo:SCROLLINFO
		LOCAL newWidth:DWORD, newHeight:DWORD
		LOCAL buffer[100]:BYTE, numBytesRead:DWORD, fileNamePtr:DWORD

	MOV	EAX, uMsg
	CMP	EAX, WM_SIZE
	JE	do_size
	CMP	EAX, WM_COMMAND
	JE	do_command
	CMP	EAX, WM_CREATE
	JE	do_create
	CMP	EAX, WM_CLOSE
	JE	do_close

dodefault:
; use DefWindowProc for all other messages:
	INVOKE	DefWindowProc, hWin, uMsg, wParam, lParam
	RET

;===== case WM_SIZE: =====
do_size:
	INVOKE	GetClientRect, hWin, ADDR gpRect
;	MOVZX	EAX, WORD PTR lParam
;	MOV	newWidth, EAX
;	MOVZX	EAX, WORD PTR lParam + 2
;	MOV	newHeight, EAX
	INVOKE	MoveWindow, StringsWinHandle, 0, 0, gpRect.right, gpRect.bottom, TRUE
;	INVOKE	MoveWindow, StringsWinHandle, 0, 0, newWidth, newHeight, TRUE
	XOR	EAX, EAX
	RET

;===== case WM_COMMAND: =====
do_command:
	MOV	AX, WORD PTR wParam
	CMP	AX, $menuOpenFile
	JE	do_openfile
	CMP	AX, $menuExit
	JE	do_close

;===== case WM_CREATE: =====
do_create:
; Load a fixed-width font for the listbox window:
	INVOKE	CreateFont, $stringsFontSize, 0, 0, 0, FW_NORMAL, FALSE, FALSE, FALSE,
		ANSI_CHARSET, OUT_DEFAULT_PRECIS,  CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
		FIXED_PITCH OR FF_MODERN, ADDR FontName
	MOV	StringsFontHandle, EAX

; Get size of main window:
	INVOKE	GetClientRect, hWin, ADDR gpRect

; Use size to create listbox for strings:
	INVOKE	CreateWindowEx, 0, ADDR StringsClassName, NULL, $stringsWinAttrs, 0,
		0, gpRect.right, gpRect.bottom, hWin, NULL, InstanceHandle, NULL
	MOV	StringsWinHandle, EAX

	INVOKE	SendMessage, EAX, WM_SETFONT, StringsFontHandle, FALSE
; Subclass the listbox control:
;	INVOKE	SetWindowLong, StringsWinHandle, GWL_WNDPROC, ADDR StringsWinProc
;	MOV	OldListboxProcPtr, EAX

	MOV	HeapPtr, NULL			;Indicate heap hasn't been allocated.
	XOR	EAX, EAX
	RET

;===== case WM_CLOSE: =====
do_close:
	INVOKE	PostQuitMessage, NULL
	MOV	EAX, TRUE
	RET

do_openfile:
	INVOKE	OpenFileDlg, hWin, ADDR fileOpenName
; Look at result from GetOpenFileName() to see if user selected a file
; (result will be zero if user cancels, doesn't select a file or an error occurs):
	OR	EAX, EAX
	JZ	open10
open8:	INVOKE	CreateFile, ADDR fileOpenName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL, NULL
; See if file open succeeded:
	CMP	EAX, INVALID_HANDLE_VALUE
	JNE	open20
	INVOKE	MessageBox, hWin, ADDR FileOpenErrMsg, ADDR ErrorCaption, MB_OK
open10:	JMP	open90

open20:	MOV	ReadFileHandle, EAX
; Deallocate heap if previously allocated:
	CMP	HeapPtr, NULL
	JE	open25
	INVOKE	HeapFree, HeapHandle, 0, HeapPtr
	MOV	HeapPtr, NULL			;Mark ptr as unused
open25:	INVOKE	GetFileSize, ReadFileHandle, NULL
	MOV	ReadFileSize, EAX
	ADD	EAX, 100			;Pad our allocation.
	INVOKE	HeapAlloc, HeapHandle, 0,  EAX
; Check that memory allocation succeeded:
	OR	EAX, EAX
	JNZ	open30
	INVOKE	MessageBox, hWin, ADDR Memfailmsg, addr ErrorCaption, MB_OK
	JMP	SHORT open40

open30:
	MOV	HeapPtr, EAX			;Save pointer to allocated heap
	INVOKE	ReadFile, ReadFileHandle, HeapPtr, ReadFileSize, ADDR numBytesRead, NULL
	OR	EAX, EAX
	JNZ	open35
	INVOKE	MessageBox, hWin, ADDR Readfailmsg, ADDR ErrorCaption, MB_OK
	JMP	SHORT open40

open35:	CALL	FindStrings
;	INVOKE	InvalidateRect, StringsWinHandle, NULL, FALSE	;Force repaint.
open40:	INVOKE	CloseHandle, ReadFileHandle
open90:	XOR	EAX, EAX
	RET


MainWindowProc	ENDP

if 0
;====================================================================
; String listbox window proc
;
; Not currently used; created more problems than it solved.
;====================================================================

StringsWinProc	PROC hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
		LOCAL ps:PAINTSTRUCT

	MOV	EAX, uMsg
	CMP	EAX, WM_PAINT
	JE	do_paint

dodefault:
	INVOKE	CallWindowProc, OldListboxProcPtr, hWin, uMsg, wParam, lParam
	RET

;===== case WM_PAINT: =====
do_paint:
	CMP	HeapPtr, NULL
	JE	dodefault
	INVOKE	BeginPaint, hWin, ADDR ps
	CALL	FindStrings
	INVOKE	EndPaint, hWin, ADDR ps
	XOR	EAX, EAX
	RET	

StringsWinProc	ENDP
endif

;====================================================================
; FindStrings()
;
; ASS-U-MEs that a file has been opened and read into the heap
; (pointed to by HeapPtr). Size of file is in ReadFileSize.
;====================================================================

FindStrings	PROC
		LOCAL stringLen:DWORD, filePtr:DWORD, stringBuffer[$maxStringLen + 4]:BYTE
		LOCAL scanOff:DWORD, count:DWORD

	PUSH	ESI
	PUSH	EDI
	MOV	ESI, HeapPtr
	MOV	EAX, ReadFileSize
	MOV	count, EAX
fs5:	LEA	EDI, stringBuffer
	MOV	stringLen, 0
	MOV	scanOff, FALSE
fs10:	DEC	count
	JZ	fs_EOF
	LODSB	
; Exclude non-ASCII characters from string:
	CMP	AL, $ASCIImin
	JB	fs20
	CMP	AL, $ASCIImax
	JA	fs20
; If char is space, check AllowSpaces flag:
	CMP	AL, ' '
	JNE	@F
	CMP	AllowSpaces, TRUE
	JNE	fs20
@@:	CMP	scanOff, TRUE			;Are we scanning off a string?
	JE	fs10				;  Yep, get next char.
@@:	CMP	stringLen, $maxStringLen
	JE	fs30
	INC	stringLen
	STOSB
	JMP	fs10

; Max. string length hit, so we must output string and scan the remainder off:
fs30:	MOV	BYTE PTR [EDI], 0		;Make ASCIIZ.
	INVOKE	SendMessage, StringsWinHandle, LB_ADDSTRING, 0, ADDR stringBuffer
	MOV	scanOff, TRUE
	JMP	fs10

; Non-ASCII char seen: is there a string to output?
fs20:	CMP	stringLen, $minStringLen
	JB	fs5				;No, keep scanning.
; Output string to listbox:
	MOV	BYTE PTR [EDI], 0		;Make ASCIIZ.
	INVOKE	SendMessage, StringsWinHandle, LB_ADDSTRING, 0, ADDR stringBuffer
	JMP	fs5				;Reset, keep scanning.

fs_EOF:	CMP	stringLen, $minStringLen
	JB	fs99
	MOV	BYTE PTR [EDI], 0		;Make ASCIIZ.
	INVOKE	SendMessage, StringsWinHandle, LB_ADDSTRING, 0, ADDR stringBuffer

fs99:	POP	EDI
	POP	ESI
	RET

FindStrings	ENDP


;=====================================================
; OpenFileDlg()
;
; Basically a wrapper for GetOpenFileName()
; Sets up needed structure, invokes file-selection
; dialog.
;
; On exit,
;   EAX = return value (zero if user cancelled or
;	selected no file)
;=====================================================

OpenFileDlg	PROC	hWin:HWND, fileOpenNamePtr:DWORD
	LOCAL	ofn:OPENFILENAME, buffer[40]:byte

; First, zero out entire structure:
	PUSH	EDI
	LEA	EDI, ofn
	MOV	ECX, SIZEOF OPENFILENAME
	XOR	EAX, EAX
	REP	STOSB					;Zero it out.
	POP	EDI

	MOV	ofn.lStructSize, SIZEOF OPENFILENAME
	MOV	EAX, hWin
	MOV	ofn.hWndOwner, EAX
	MOV	EAX, InstanceHandle
	MOV	ofn.hInstance, EAX
	MOV	EAX, fileOpenNamePtr
	MOV	ofn.lpstrFile, EAX
	PUSH	ESI
	PUSH	EDI
	LEA	ESI, FileStartPathStr
	MOV	EDI, EAX				;EAX = fileOpenNamePtr
	CALL	strcpy
	POP	EDI
	POP	ESI
	MOV	ofn.nMaxFile, $fileOpenStrLen
	MOV	ofn.lpstrTitle, OFFSET FileOpenDlgTitle
	MOV	ofn.Flags, OFN_EXPLORER OR OFN_FILEMUSTEXIST OR OFN_LONGNAMES OR OFN_HIDEREADONLY
	INVOKE	GetOpenFileName, ADDR ofn
;	MOV	EDX, ofn.lpstrFile
	RET

OpenFileDlg	ENDP


;====================================================================
; strcpy()
;====================================================================

strcpy		PROC

scp10:	MOV	AL, BYTE PTR [ESI]
	MOV	[EDI], BYTE PTR AL
	OR	AL, AL			;Stop on NULL.
	JZ	scp99
	INC	ESI
	INC	EDI
	JMP	scp10

scp99:	RET

strcpy		ENDP


;====================================================================
; CenterDim
;
; Returns half screen dimension (X or Y) minus half window dimension
;
; On entry,
;	EAX = screen dimension
;	EDX = window dimension
;
; Returns:
;	sdim/2 - wdim/2
;====================================================================

CenterDim	PROC

	SHR	EAX, 1				;divide screen dimension by 2
	SHR	EDX, 1				;divide window dimension by 2
	SUB	EAX, EDX
	RET					;Return w/# in EAX

CenterDim	ENDP


	END	start

